clear all;
close all;

lambda = input('lambda = ');
a = input('a = ');
rho = input('rho = ');

BP_step = 10000;
dmp = 0.1;

load('crime_data_predictor_modify_std.mat');
str = sprintf('crime_data_sample_2_rho%.2f.mat', rho);
load(str);

A = crime_data_predictor_modify_std;

M = size(A,1);
N = size(A,2);
K = round(N*rho);

P_train = size(y_train,2);
P_test = size(y_test,2);

mu_y0 = A*x0;
A2 = A.^2;

err = zeros(P_train,1);
df = zeros(P_train,1);
df_estimator = zeros(P_train,1);
df_estimator_app = zeros(P_train,1);

rhoh = zeros(P_train,1);
pre_err = zeros(P_train,1);

pre_err_estimator = pre_err;
pre_err_estimator_app = pre_err;

conv_check = pre_err;

for n_r = 1: P_train
     
    y = y_train(:,n_r);
    
    % initial condition
    X = pinv(A)*y;
    y_hat = A*X;
    v_x = rand(size(X,1),1);
    w = y-y_hat;
    v_y = A2*v_x;

    shusoku = 0;
    bp_count = 0;

    while (shusoku == 0 && bp_count < BP_step)
    
        bp_count = bp_count + 1;
    
        X_old = X;
        v_x_old = v_x;

        V = A2*v_x;
        w = A*X-V.*((y-w)./(1+V));
        Sigma2 = 1./(A2'*(1./(1+V)));
        R = X + Sigma2.*(A'*((y-w)./(1+V)));

        theta_1 = (abs(R)>lambda*Sigma2).*(abs(R)<=a*lambda);
        theta_2 = (abs(R)>a*lambda);

        var_1 = Sigma2./(1-Sigma2/a);
        var_2 = Sigma2;

        X = (R-lambda*Sigma2.*sign(R))./(1-Sigma2/a).*theta_1...
            +R.*theta_2;

        v_x = var_1.*theta_1+var_2.*theta_2;

        shusoku = (sum(abs(X-X_old)<1e-10) == size(X,1));
    
        X = dmp*rand(1)*(X-X_old)+X_old;
        v_x = dmp*rand(1)*(v_x-v_x_old)+v_x_old;
        
        y_hat = A*X;
        v_y = A2*v_x;
    end

    conv_check(n_r) = (bp_count==BP_step);
    if bp_count < BP_step

        err(n_r) = (y-y_hat)'*(y-y_hat)/M;
        df(n_r) = (y-mu_y0)'*y_hat/M/sigma_OLS^2;
        rhoh(n_r) = sum(theta_1+theta_2)/N;
        pre_err(n_r) = mean(mean((y_test-y_hat*ones(1,P_test)).^2));
    
        df_estimator(n_r) = mean(v_y./(1+v_y));
        pre_err_estimator(n_r) = err(n_r) + 2*sigma_OLS^2*df_estimator(n_r);

        X_active_all = [find(theta_1); find(theta_2)];
        AS = A(:,X_active_all);
        Phi = zeros(size(X_active_all,1),1);
        Phi(1:size(find(theta_1),1)) = 1/a;
        Phi_mat = diag(Phi);
        v_x_app = zeros(N,1);
        v_x_app(X_active_all) = diag(inv(AS'*AS-Phi_mat));
        V_app = A2*v_x_app;
        df_estimator_app(n_r) = mean(V_app./(1+V_app));
        pre_err_estimator_app(n_r) = err(n_r) + 2*sigma_OLS^2*df_estimator_app(n_r);
        
    end
end

nonconv_ind = find(conv_check);
n_sample = P_test - size(nonconv_ind,1);
df(nonconv_ind) = [];
df_estimator(nonconv_ind) = [];
df_estimator_app(nonconv_ind) = [];
rhoh(nonconv_ind) = [];
err(nonconv_ind) = [];
pre_err(nonconv_ind) = [];
pre_err_estimator(nonconv_ind) = [];
pre_err_estimator_app(nonconv_ind) = [];

