clear all;
close all;

P_train = 1000;
P_test = 1000;

load('crime_data_predictor_modify_std.mat');
load('crime_data_output_std.mat');

A = crime_data_predictor_modify_std;
y_full = crime_data_output_std;
y_output = y_full(:,2);

M = size(A,1);
N = size(A,2);

rho = input('rho = ');
K = round(N*rho);

% get true signal
x0 = zeros(N,1);
x_OLS = (A'*A)\A'*y_output;
[val,ind] = sort(abs(x_OLS),'descend');
supp = ind(1:K);
x0(supp) = x_OLS(supp);
mu_y0 = A*x0;
r = y_output-mu_y0;
sigma_OLS = sqrt((r'*r)/M);

% generate training sample
y_train = mu_y0*ones(1,P_train) + sigma_OLS*randn(M,P_train);
y_test = mu_y0*ones(1,P_test) + sigma_OLS*randn(M,P_test);

str = sprintf('crime_data_sample_2_rho%.2f.mat', rho);
save(str, 'y_train', 'y_test', 'x0', 'sigma_OLS');